import ddf.minim.*;
import ddf.minim.analysis.*;

Minim minim;
AudioPlayer song;
BeatDetect beat;
BeatListener bl;

int rotation =1;

void setup()
{
  size(400, 400);
  minim = new Minim(this);
  song = minim.loadFile("TicketToRide.mp3",32768);
  song.play();
  // a beat detection object song SOUND_ENERGY mode with a sensitivity of 10 milliseconds
  beat = new BeatDetect(song.bufferSize(), song.sampleRate());
  beat.setSensitivity(200);
  bl = new BeatListener(beat, song);
  background(50,200);
}

void draw()
{
  //beat.detect(song.mix);
  if( beat.isRange(1,25, 1)  )
  {
    background(50,200);
    pushMatrix();
    translate(width/2, height/2) ;
    rotate(rotation*PI/6) ;
    translate(0, width * (0.3+0.0*rotation)) ;
    scale(0.25) ;
    drawHog();
    popMatrix() ;
    rotation++;
  }
}

void drawHog () {
  fill(0);

  quad(-150,150,-100,150,-30,170,-50,200);  //shadow
  fill(162,112,30);
  quad(0,0,100,0,150,200,-50,200);  //body
  // face
  fill(0);
  ellipse(18,16,8,8);
  ellipse(82,16,8,8);
  triangle(42,32,58,32,50,26);
  rect(34,48,32,8);
}

void stop()
{
  // always close Minim audio classes when you are finished with them
  song.close();
  // always stop Minim before exiting
  minim.stop();

  super.stop();
}

